// Her brukes to DFS, men enklere kode i hvert soek enn det andre forslaget.
// Begge er riktige og har samme asymptotiske kjoeretid: O(N).
#include <iostream>
#include <vector>

using namespace std;

int n;
vector<vector<int> > M;
vector<bool> visited;
int farNode = -1;
int maxDepth = -1;

void visit(int node, int depth) {
  visited[node] = true;  // Marker at noden er besoekt.
  if (depth > maxDepth) {
    maxDepth = depth;
    farNode = node;
  }
  for (int i = 0; i < M[node].size(); ++i) {
    int next = M[node][i];
    if (!visited[next]) {
      visit(next, depth + 1);
    }
  }
}

int main() {
  cin >> n;
  M.resize(n);
  visited.resize(n);
  int a, b;
  for (int i = 0; i < n - 1; ++i) {
    visited[i] = false;
    cin >> a >> b;
    M[a].push_back(b);
    M[b].push_back(a);
  }
  visited[n-1] = false;

  // Finn node lengst unna tilfeldig node (denne er en av de to nodene lengst
  // unna hverandre)
  visit(0, 0);
  int startNode = farNode;

  // Rens datastrukturer
  for (int i = 0; i < n; ++i) {
    visited[i] = false;
  }
  maxDepth = -1;
  farNode = -1;
  visit(startNode, 0);

  cout << (2 * (n - 1) - maxDepth) << endl;
  return 0;
}
